import pygame
import sys
import time
import math
# Initialize Pygame
pygame.init()
pygame.mixer.music.load("jungle.mp3")
pygame.mixer.music.set_volume(0.4)
pygame.mixer.music.play(-1)
shopsf = pygame.mixer.Sound("shopmenusound.mp3")
shopvol = 0.2
shopsf.set_volume(shopvol)
redsf = pygame.mixer.Sound("interface.mp3")
redvol = 0.5
redsf.set_volume(redvol)
clicksf = pygame.mixer.Sound("clicksound.wav")
clickvol = 0.2
clicksf.set_volume(clickvol)
buysf = pygame.mixer.Sound("purchasesound.mp3")
buyvol = 0.5
buysf.set_volume(buyvol)
# Constants
title_screen_active = False
SCREEN_WIDTH = 900
SCREEN_HEIGHT = 700
FPS = 60
# Colors
WHITE = (255, 255, 255)
BLACK = (0, 0, 0)
RED = (255, 0, 0)
GREEN = (0, 255, 0, 0)
BLUE = (0, 0, 255)
# Game variables
gems = 0
godgems = 0
green_gems = 0
red_gems = 0
blue_gems = 0

milestone_counter = 0
lifetime_gems_milestone = 0
lifetime_gems = 0
# Time variables for auto clickers
# Back GUI
backk = pygame.image.load("gameback-01.png")
backimg = pygame.transform.scale(backk, (SCREEN_WIDTH, SCREEN_HEIGHT))
sbackk = pygame.image.load("shopbackimg-01.png")
shopimg = pygame.transform.scale(sbackk, (SCREEN_WIDTH, SCREEN_HEIGHT))

auto_clickers = {"green": 0, "red": 0, "blue": 0, "bakery": 0, "fastfood": 0, "factory": 0, "office": 0, "jimjon": 0, "lambo": 0, "sailboat": 0, "spaceship": 0, "godmode":0}  # first 3 purchases
last_click_time = time.time()
last_click_time2 = time.time()
last_click_timeprius = time.time()
last_click_timebake = time.time()
last_click_timefood = time.time()
last_click_timefactory = time.time()
last_click_timeoffice = time.time()
last_click_timejimjon = time.time()
last_click_timelambo = time.time()
last_click_timesailboat = time.time()
last_click_timespaceship = time.time()
last_click_timegodmode = time.time()

# Read user stats from file
try:
    with open("user_stats.txt", "r") as file:
        lines = file.readlines()
        gems = int(lines[0].split(":")[1].strip())
        green_gems = int(lines[1].split(":")[1].strip())
        red_gems = int(lines[2].split(":")[1].strip())
        blue_gems = int(lines[3].split(":")[1].strip())
        auto_clickers["green"] = int(lines[4].split(":")[1].strip())  # first purchase
        auto_clickers["red"] = int(lines[5].split(":")[1].strip())
        auto_clickers["blue"] = int(lines[6].split(":")[1].strip())
        godgems = int(lines[7].split(":")[1].strip())
        auto_clickers["bakery"] = int(lines[8].split(":")[1].strip())
        auto_clickers["fastfood"] = int(lines[9].split(":")[1].strip())
        auto_clickers["factory"] = int(lines[10].split(":")[1].strip())
        auto_clickers["office"] = int(lines[11].split(":")[1].strip()) 
        auto_clickers["jimjon"] = int(lines[12].split(":")[1].strip())
        auto_clickers["lambo"] = int(lines[13].split(":")[1].strip())
        auto_clickers["sailboat"] = int(lines[14].split(":")[1].strip())
        auto_clickers["spaceship"] = int(lines[15].split(":")[1].strip()) 
        auto_clickers["godmode"] = int(lines[16].split(":")[1].strip())
except FileNotFoundError:
    # File not found, initialize with default values
    pass
# Create the game window
screen = pygame.display.set_mode((SCREEN_WIDTH, SCREEN_HEIGHT))
pygame.display.set_caption("Clicker Game")
# Load images
gem_image = pygame.Surface((120, 120), pygame.SRCALPHA)
pygame.draw.circle(gem_image, GREEN, (250, 250), 700)
# Fonts
font = pygame.font.Font(None, 36)
# Clock for controlling the frame rate
clock = pygame.time.Clock()
def update_display():
    screen.blit(backimg, (0, 0))
    screen.blit(gem_image, (SCREEN_WIDTH // 2 - 25 - 35, SCREEN_HEIGHT // 2 - 25 - 25))
    # Display user stats
    green_gem = font.render(f"{green_gems}", True, BLACK)
    red_gem = font.render(f"{red_gems}", True, BLACK)
    blue_gem = font.render(f"{blue_gems}", True, BLACK)
    screen.blit(green_gem, (99, 23))
    screen.blit(red_gem, (399, 23))
    screen.blit(blue_gem, (705, 23))
    if title_screen_active:
        draw_title_screen()
    pygame.display.flip()
def draw_title_screen():
    screen.blit(shopimg, (0, 0))
    green_gem = font.render(f"{green_gems}", True, BLACK)
    red_gem = font.render(f"{red_gems}", True, BLACK)
    blue_gem = font.render(f"{blue_gems}", True, BLACK)
    screen.blit(green_gem, (150, 223))
    screen.blit(red_gem, (395, 223))
    screen.blit(blue_gem, (649, 223))
# Function to handle the purchase logic for the first one
    
def purchase_auto_clicker():
    global green_gems, auto_clickers, last_click_time
    cost_per_clicker = 200
    # Check if the player has enough green gems
    if green_gems >= cost_per_clicker:
        green_gems -= cost_per_clicker
        buysf.play()
        auto_clickers["green"] += 1
        last_click_time = time.time()  # Reset the timer

def purchase_auto_clicker2():
    global green_gems, auto_clickers, last_click_time2
    cost_per_clicker = 2000
    # Check if the player has enough green gems
    if green_gems >= cost_per_clicker:
        green_gems -= cost_per_clicker
        buysf.play()
        auto_clickers["red"] += 2
        last_click_time2 = time.time()  # Reset the timer

def purchase_auto_clicker3prius():
    global green_gems, auto_clickers, last_click_timeprius
    cost_per_clicker = 25000
    # Check if the player has enough green gems
    if green_gems >= cost_per_clicker:
        green_gems -= cost_per_clicker
        buysf.play()
        auto_clickers["blue"] += 5
        last_click_timeprius= time.time()  # Reset the timer

def purchase_auto_clicker4bakery():
    global green_gems, auto_clickers, last_click_timebake
    cost_per_clicker = 100000
    # Check if the player has enough green gems
    if green_gems >= cost_per_clicker:
        green_gems -= cost_per_clicker
        buysf.play()
        auto_clickers["bakery"] += 8
        last_click_timebake= time.time()  # Reset the timer

def purchase_auto_clicker5fastfood():
    global red_gems, auto_clickers, last_click_timefood
    cost_per_clicker = 200
    # Check if the player has enough green gems
    if red_gems >= cost_per_clicker:
        red_gems -= cost_per_clicker
        buysf.play()
        auto_clickers["fastfood"] += 12
        last_click_timefood= time.time()  # Reset the timer

def purchase_auto_clicker6factory():
    global red_gems, auto_clickers, last_click_timefactory
    cost_per_clicker = 25000
    # Check if the player has enough green gems
    if red_gems >= cost_per_clicker:
        red_gems -= cost_per_clicker
        buysf.play()
        auto_clickers["factory"] += 18
        last_click_timefactory= time.time()  # Reset the timer

def purchase_auto_clicker7office():
    global red_gems, auto_clickers, last_click_timeoffice
    cost_per_clicker = 2000
    # Check if the player has enough green gems
    if red_gems >= cost_per_clicker:
        red_gems -= cost_per_clicker
        buysf.play()
        auto_clickers["office"] += 15
        last_click_timeoffice= time.time()  # Reset the timer

def purchase_auto_clicker8jimjon():
    global red_gems, auto_clickers, last_click_timejimjon
    cost_per_clicker = 100000
    # Check if the player has enough green gems
    if red_gems >= cost_per_clicker:
        red_gems -= cost_per_clicker
        buysf.play()
        auto_clickers["jimjon"] += 22
        last_click_timejimjon= time.time()  # Reset the timer

def purchase_auto_clicker9lambo():
    global blue_gems, auto_clickers, last_click_timelambo
    cost_per_clicker = 200
    # Check if the player has enough green gems
    if blue_gems >= cost_per_clicker:
        blue_gems -= cost_per_clicker
        buysf.play()
        auto_clickers["lambo"] += 25
        last_click_timelambo= time.time()  # Reset the timer

def purchase_auto_clicker10sailboat():
    global blue_gems, auto_clickers, last_click_timesailboat
    cost_per_clicker = 2000
    # Check if the player has enough green gems
    if blue_gems >= cost_per_clicker:
        blue_gems -= cost_per_clicker
        buysf.play()
        auto_clickers["sailboat"] += 30
        last_click_timesailboat= time.time()  # Reset the timer

def purchase_auto_clicker11spaceship():
    global blue_gems, auto_clickers, last_click_timespaceship
    cost_per_clicker = 25000
    # Check if the player has enough green gems
    if blue_gems >= cost_per_clicker:
        blue_gems -= cost_per_clicker
        buysf.play()
        auto_clickers["spaceship"] += 40
        last_click_timespaceship= time.time()  # Reset the timer

def purchase_auto_clicker12godmode():
    global blue_gems, auto_clickers, last_click_timegodmode
    cost_per_clicker = 100000
    # Check if the player has enough green gems
    if blue_gems >= cost_per_clicker:
        blue_gems -= cost_per_clicker
        buysf.play()
        auto_clickers["godmode"] += 50
        last_click_timegodmode= time.time()  # Reset the timer



# Game loop
running = True
while running:
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            running = False
        elif event.type == pygame.MOUSEBUTTONDOWN:
            x, y = pygame.mouse.get_pos()
            if SCREEN_WIDTH // 2 - 80 <= x <= SCREEN_WIDTH // 2 + 80 and SCREEN_HEIGHT // 2 - 80 <= y <= SCREEN_HEIGHT // 2 + 80 and title_screen_active == False:
                gems += 1
                godgems += 1
                green_gems += 1
                clicksf.play()

                # Check for gem milestones
                lifetime_gems += 1

                if lifetime_gems % 1000 == 0:
                    red_gems += 1
                    redsf.play()
                    lifetime_gems = 0

                if godgems % 10000 == 0:
                    blue_gems += 1
                    redsf.play()
                    godgems = 0

            elif 110 <= x <= 185 and 296 <= y <= 360 and title_screen_active:
                # Purchase button clicked
                
                purchase_auto_clicker()  # first clicker

            elif 220 <= x <= 285 and 296 <= y <= 360 and title_screen_active:
                # Purchase button clicked
                purchase_auto_clicker2()

            elif 110 <= x <= 185 and 396 <= y <= 480 and title_screen_active:
                # Purchase button clicked
                purchase_auto_clicker3prius()

            elif 220 <= x <= 285 and 396 <= y <= 480 and title_screen_active:
                # Purchase button clicked
                purchase_auto_clicker4bakery()
            
            elif 330 <= x <= 405 and 296 <= y <= 360 and title_screen_active:
                # Purchase button clicked
                purchase_auto_clicker5fastfood()

            elif 330 <= x <= 405 and 396 <= y <= 480 and title_screen_active:
                # Purchase button clicked
                purchase_auto_clicker6factory()

            elif 450 <= x <= 520 and 296 <= y <= 380 and title_screen_active:
                # Purchase button clicked
                purchase_auto_clicker7office()

            elif 450 <= x <= 520 and 396 <= y <= 480 and title_screen_active:
                # Purchase button clicked
                purchase_auto_clicker8jimjon()

            elif 570 <= x <= 625 and 296 <= y <= 380 and title_screen_active:
                # Purchase button clicked
                purchase_auto_clicker9lambo()

            elif 680 <= x <= 755 and 296 <= y <= 380 and title_screen_active:
                # Purchase button clicked
                purchase_auto_clicker10sailboat()

            elif 570 <= x <= 625 and 396 <= y <= 480 and title_screen_active:
                # Purchase button clicked
                purchase_auto_clicker11spaceship()

            elif 680 <= x <= 755 and 396 <= y <= 480 and title_screen_active:
                # Purchase button clicked
                purchase_auto_clicker12godmode()



        elif event.type == pygame.KEYDOWN:

            if event.key == pygame.K_SPACE:
                shopsf.play()
                # Toggle title screen
                title_screen_active = not title_screen_active


    current_timelambo = time.time()
    time_elapsedlambo = current_timelambo - last_click_timelambo
    if time_elapsedlambo >= 15 and auto_clickers["lambo"] > 0:
        # Auto click every 10 seconds for each auto clicker
        gems += auto_clickers["lambo"]
        godgems += auto_clickers["lambo"]
        green_gems += auto_clickers["lambo"]
        last_click_timelambo = current_timelambo
        clicksf.play()
        lifetime_gems += auto_clickers["lambo"]
        # Adjusted logic for red gem milestones
        while lifetime_gems >= 1000:
            red_gems += 1
            lifetime_gems -= 1000
            redsf.play()
        # Adjusted logic for blue gem milestones
        while godgems >= 10000:
            blue_gems += 1
            godgems -= 10000
            redsf.play()

    current_timesailboat = time.time()
    time_elapsedsailboat = current_timesailboat - last_click_timesailboat
    if time_elapsedsailboat >= 15 and auto_clickers["sailboat"] > 0:
        # Auto click every 10 seconds for each auto clicker
        gems += auto_clickers["sailboat"]
        godgems += auto_clickers["sailboat"]
        green_gems += auto_clickers["sailboat"]
        last_click_timesailboat = current_timesailboat
        clicksf.play()
        lifetime_gems += auto_clickers["sailboat"]
        # Adjusted logic for red gem milestones
        while lifetime_gems >= 1000:
            red_gems += 1
            lifetime_gems -= 1000
            redsf.play()
        # Adjusted logic for blue gem milestones
        while godgems >= 10000:
            blue_gems += 1
            godgems -= 10000
            redsf.play()

    current_timespaceship = time.time()
    time_elapsedspaceship = current_timespaceship - last_click_timespaceship
    if time_elapsedspaceship >= 15 and auto_clickers["spaceship"] > 0:
        # Auto click every 10 seconds for each auto clicker
        gems += auto_clickers["spaceship"]
        godgems += auto_clickers["spaceship"]
        green_gems += auto_clickers["spaceship"]
        last_click_timespaceship = current_timespaceship
        clicksf.play()
        lifetime_gems += auto_clickers["spaceship"]
        # Adjusted logic for red gem milestones
        while lifetime_gems >= 1000:
            red_gems += 1
            lifetime_gems -= 1000
            redsf.play()
        # Adjusted logic for blue gem milestones
        while godgems >= 10000:
            blue_gems += 1
            godgems -= 10000
            redsf.play()

    current_timegodmode = time.time()
    time_elapsedgodmode = current_timegodmode - last_click_timegodmode
    if time_elapsedgodmode >= 15 and auto_clickers["godmode"] > 0:
        # Auto click every 10 seconds for each auto clicker
        gems += auto_clickers["godmode"]
        godgems += auto_clickers["godmode"]
        green_gems += auto_clickers["godmode"]
        last_click_timegodmode = current_timegodmode
        clicksf.play()
        lifetime_gems += auto_clickers["godmode"]
        # Adjusted logic for red gem milestones
        while lifetime_gems >= 1000:
            red_gems += 1
            lifetime_gems -= 1000
            redsf.play()
        # Adjusted logic for blue gem milestones
        while godgems >= 10000:
            blue_gems += 1
            godgems -= 10000
            redsf.play()

    current_timeoffice = time.time()
    time_elapsedoffice = current_timeoffice - last_click_timeoffice
    if time_elapsedoffice >= 15 and auto_clickers["office"] > 0:
        # Auto click every 10 seconds for each auto clicker
        gems += auto_clickers["office"]
        godgems += auto_clickers["office"]
        green_gems += auto_clickers["office"]
        last_click_timeoffice = current_timeoffice
        clicksf.play()
        lifetime_gems += auto_clickers["office"]
        # Adjusted logic for red gem milestones
        while lifetime_gems >= 1000:
            red_gems += 1
            lifetime_gems -= 1000
            redsf.play()
        # Adjusted logic for blue gem milestones
        while godgems >= 10000:
            blue_gems += 1
            godgems -= 10000
            redsf.play()

    current_timefactory = time.time()
    time_elapsedfactory = current_timefactory - last_click_timefactory
    if time_elapsedfactory >= 20 and auto_clickers["factory"] > 0:
        # Auto click every 10 seconds for each auto clicker
        gems += auto_clickers["factory"]
        godgems += auto_clickers["factory"]
        green_gems += auto_clickers["factory"]
        last_click_timefactory = current_timefactory
        clicksf.play()
        lifetime_gems += auto_clickers["factory"]
        # Adjusted logic for red gem milestones
        while lifetime_gems >= 1000:
            red_gems += 1
            lifetime_gems -= 1000
            redsf.play()
        # Adjusted logic for blue gem milestones
        while godgems >= 10000:
            blue_gems += 1
            godgems -= 10000
            redsf.play()

    current_timejimjon = time.time()
    time_elapsedjimjon = current_timejimjon - last_click_timejimjon
    if time_elapsedjimjon >= 22 and auto_clickers["jimjon"] > 0:
        # Auto click every 10 seconds for each auto clicker
        gems += auto_clickers["jimjon"]
        godgems += auto_clickers["jimjon"]
        green_gems += auto_clickers["jimjon"]
        last_click_timejimjon = current_timejimjon
        clicksf.play()
        lifetime_gems += auto_clickers["jimjon"]
        # Adjusted logic for red gem milestones
        while lifetime_gems >= 1000:
            red_gems += 1
            lifetime_gems -= 1000
            redsf.play()
        # Adjusted logic for blue gem milestones
        while godgems >= 10000:
            blue_gems += 1
            godgems -= 10000
            redsf.play()

    current_time2 = time.time()
    time_elapsedfood = current_time2 - last_click_timefood
    if time_elapsedfood >= 18 and auto_clickers["fastfood"] > 0:
        # Auto click every 10 seconds for each auto clicker
        gems += auto_clickers["fastfood"]
        godgems += auto_clickers["fastfood"]
        green_gems += auto_clickers["fastfood"]
        last_click_timefood = current_time2
        clicksf.play()
        lifetime_gems += auto_clickers["fastfood"]
        # Adjusted logic for red gem milestones
        while lifetime_gems >= 1000:
            red_gems += 1
            lifetime_gems -= 1000
            redsf.play()
        # Adjusted logic for blue gem milestones
        while godgems >= 10000:
            blue_gems += 1
            godgems -= 10000
            redsf.play()

    current_time3 = time.time()
    time_elapsedbake = current_time3 - last_click_timebake
    if time_elapsedbake >= 15 and auto_clickers["bakery"] > 0:
        # Auto click every 10 seconds for each auto clicker
        gems += auto_clickers["bakery"]
        godgems += auto_clickers["bakery"]
        green_gems += auto_clickers["bakery"]
        last_click_timebake = current_time3
        clicksf.play()
        lifetime_gems += auto_clickers["bakery"]
        # Adjusted logic for red gem milestones
        while lifetime_gems >= 1000:
            red_gems += 1
            lifetime_gems -= 1000
            redsf.play()
        # Adjusted logic for blue gem milestones
        while godgems >= 10000:
            blue_gems += 1
            godgems -= 10000
            redsf.play()

    current_time4 = time.time()
    time_elapsed3 = current_time4 - last_click_timeprius
    if time_elapsed3 >= 10 and auto_clickers["blue"] > 0:
        # Auto click every 10 seconds for each auto clicker
        gems += auto_clickers["blue"]
        godgems += auto_clickers["blue"]
        green_gems += auto_clickers["blue"]
        last_click_timeprius = current_time4
        clicksf.play()
        lifetime_gems += auto_clickers["blue"]
        # Adjusted logic for red gem milestones
        while lifetime_gems >= 1000:
            red_gems += 1
            lifetime_gems -= 1000
            redsf.play()
        # Adjusted logic for blue gem milestones
        while godgems >= 10000:
            blue_gems += 1
            godgems -= 10000
            redsf.play()

    current_time5 = time.time()
    time_elapsed2 = current_time5 - last_click_time2
    if time_elapsed2 >= 5 and auto_clickers["red"] > 0:
        # Auto click every 10 seconds for each auto clicker
        gems += auto_clickers["red"]
        godgems += auto_clickers["red"]
        green_gems += auto_clickers["red"]
        last_click_time2 = current_time5
        clicksf.play()
        lifetime_gems += auto_clickers["red"]
        # Adjusted logic for red gem milestones
        while lifetime_gems >= 1000:
            red_gems += 1
            lifetime_gems -= 1000
            redsf.play()
        # Adjusted logic for blue gem milestones
        while godgems >= 10000:
            blue_gems += 1
            godgems -= 10000
            redsf.play()

    current_time6 = time.time()
    time_elapsed = current_time6 - last_click_time
    if time_elapsed >= 2 and auto_clickers["green"] > 0:
        # Auto click every 10 seconds for each auto clicker
        gems += auto_clickers["green"]
        godgems += auto_clickers["green"]
        green_gems += auto_clickers["green"]
        last_click_time = current_time6
        clicksf.play()
        lifetime_gems += auto_clickers["green"]
        # Adjusted logic for red gem milestones
        while lifetime_gems >= 1000:
            red_gems += 1
            lifetime_gems -= 1000
            redsf.play()
        # Adjusted logic for blue gem milestones
        while godgems >= 10000:
            blue_gems += 1
            godgems -= 10000
            redsf.play()






    while lifetime_gems >= 1000:
        red_gems += 1
        lifetime_gems -= 1000
        redsf.play()
    while godgems >= 10000:
        blue_gems += 1
        godgems -= 10000
        redsf.play()
    # Update display
    update_display()

    # Control frame rate
    clock.tick(FPS)

# Save user stats to the file before exiting
with open("user_stats.txt", "w") as file:
    file.write(f"Lifetime Gems: {gems}\n")
    file.write(f"Green Gems: {green_gems}\n")
    file.write(f"Red Gems: {red_gems}\n")
    file.write(f"Blue Gems: {blue_gems}\n")
    file.write(f"Green Auto Clickers: {auto_clickers['green']}\n")  # first
    file.write(f"Red Auto Clickers: {auto_clickers['red']}\n")  # second
    file.write(f"Blue Auto Clickers: {auto_clickers['blue']}\n")  # third
    file.write(f"GodGems: {godgems}\n")
    file.write(f"Bakery: {auto_clickers['bakery']}\n")
    file.write(f"FastFood: {auto_clickers['fastfood']}\n")
    file.write(f"Office: {auto_clickers['office']}\n")
    file.write(f"Factory: {auto_clickers['factory']}\n")
    file.write(f"JimJon: {auto_clickers['jimjon']}\n")
    file.write(f"Lambo: {auto_clickers['lambo']}\n")
    file.write(f"Sailboat: {auto_clickers['sailboat']}\n")
    file.write(f"Spaceship: {auto_clickers['spaceship']}\n")
    file.write(f"Godmode: {auto_clickers['godmode']}\n")
pygame.quit()
sys.exit()